#! /bin/bash
#
# ffmpeg_patch.sh
#

echo "Do you want to update your current XdTV FFmpeg folders with the updated SVN FFmpeg tree: [N]:"
read choice

if [ "$choice" = "Y" ]; then
svn update ../ffmpeg
rm -rf libavcodec libavformat libavutil libpostproc libswscale
cp -fva ../ffmpeg/libavcodec .
rm -rf libavcodec/alpha/.svn libavcodec/armv4l/.svn libavcodec/bfin/.svn libavcodec/x86/.svn libavcodec/mlib/.svn  libavcodec/ppc/.svn libavcodec/ps2/.svn libavcodec/sh4/.svn libavcodec/sparc/.svn libavcodec/.svn
cp -fva ../ffmpeg/libavformat .
rm -rf libavformat/.svn
cp -fva ../ffmpeg/libavutil .
rm -rf libavutil/.svn
cp -fva ../ffmpeg/libpostproc .
rm -rf libpostproc/.svn
cp -fva ../ffmpeg/libswscale .
rm -rf libswscale/.svn
cvs update -dP
fi

echo "Do you want to copy the old swscaler files to the current FFmpeg folders: [N]:"
read choice

if [ "$choice" = "Y" ]; then
cp patch/imgconvert_r17785.c libavcodec/imgconvert.c
cp patch/imgconvert_template_r17785.c libavcodec/imgconvert_template.c
cp patch/imgresample_r17785.c libavcodec/imgresample.c
cp patch/imgresample_altivec_r17785.c libavcodec/ppc/imgresample_altivec.c
cp patch/imgresample_altivec_r17785.h libavcodec/ppc/imgresample_altivec.h
fi

echo "Do you want to remplace the current FFmpeg Makefiles: [N]:"
read choice

if [ "$choice" = "Y" ]; then
cp patch/Makefile.util libavutil/Makefile
cp patch/Makefile.format libavformat/Makefile
cp patch/Makefile.postproc libpostproc/Makefile
cp patch/Makefile.codec libavcodec/Makefile
cp patch/Makefile.swscale libswscale/Makefile
fi

echo "Do you want to patch libavformat/mpegts.c ? (-> needed for a good DVB support) [N]:"
read choice

if [ "$choice" = "Y" ]; then
sed -e 's/mpegts_scan_sdt(ts);/if(0) hmpegts_scan_sdt(ts); \/\* XdTV Patch \*\//g' libavformat/mpegts.c > mpegts_patched
mv mpegts_patched libavformat/mpegts.c
sed -e 's/mpegts_set_service(ts);/if(0) mpegts_set_service(ts); \/\* XdTV Patch \*\//g' libavformat/mpegts.c > mpegts_patched
mv mpegts_patched libavformat/mpegts.c
sed -e 's/handle_packets(ts, s->probesize);/if(0) handle_packets(ts, s->probesize); \/\* XdTV Patch \*\//g' libavformat/mpegts.c > mpegts_patched
mv mpegts_patched libavformat/mpegts.c
sed -e 's/codec_id = CODEC_ID_PROBE;/codec_id = CODEC_ID_MPEG1VIDEO; \/\* XdTV Patch \*\//g' libavformat/mpegts.c > mpegts_patched
mv mpegts_patched libavformat/mpegts.c
sed -e 's/if (!pes->st ||/if (!pes->st) new_pes_av_stream(pes, code); if ( \/\* XdTV Patch \*\//g' libavformat/mpegts.c > mpegts_patched
mv mpegts_patched libavformat/mpegts.c
echo "done"
fi

echo "Do you want to tar.bz2 all XdTV FFmpeg folders: [N]:"
read choice

if [ "$choice" = "Y" ]; then
rm -rf libavcodec/CVS libavformat/CVS libavutil/CVS libpostproc/CVS libswscale/CVS
rm -rf libavcodec/.cvsignore libavformat/.cvsignore libavutil/.cvsignore libpostproc/.cvsignore libswscale/.cvsignore
rm -rf libavcodec.tar.bz2 libavformat.tar.bz2 libavutil.tar.bz2 libpostproc.tar.bz2 libswscale.tar.bz2
tar -c libavcodec > libavcodec.tar
tar -c libavformat > libavformat.tar
tar -c libavutil > libavutil.tar
tar -c libpostproc > libpostproc.tar
tar -c libswscale > libswscale.tar
bzip2 *.tar
fi
